angular
	.module( "beamng.apps" )
	.directive( "arcHybridDebug", [ function () {
		return {
			templateUrl: "modules/apps/ArcanoxHybridDebug/arc-hybrid-debug.html",
			replace: true,
			restrict: "EA",
			scope: true,
			controller: [ "$scope", "StreamsManager", function ( $scope, StreamsManager ) {
				var StreamName = "arcanox:hybrid_debug";

				StreamsManager.add( [ StreamName ] );

				$scope.$on( "$destroy", function () {
					StreamsManager.remove( [ StreamName ] );
				} );

				$scope.$on( "streamsUpdate", function ( _, streams ) {
					$scope.$evalAsync( function () {
						if ( streams != null && streams[ StreamName ] != null ) {
							var rawDebugData = streams[ StreamName ];
							var debugData = [];

							Object.keys( rawDebugData ).forEach( key => {
								var split = key.split( ":" );
								var id = +split[ 0 ];
								var name = split[ 1 ];

								debugData.push( { id, name, value: rawDebugData[ key ] } );
							} );

							$scope.debugData = $scope.debugData || [];

							angular.extend( $scope.debugData, debugData );
						} else {
							delete $scope.debugData;
						}
					} );
				} );
			} ]
		};
	} ] );
